//---------------------------------------------------
// module  : MD2S.h                         
// auteur  : Max Mignotte                            
// date    :                                              
// langage : C++                                      
// labo    :                                  
//---------------------------------------------------

#ifndef MD2S_H
#define MD2S_H

//------------------------------------------------
// FICHIERS INCLUS -------------------------------
//------------------------------------------------
#include "FunctionMD2S.h"

//------------------------------------------------
// DEFINITIONS -----------------------------------
//------------------------------------------------
#define NCHAR 200

#define UN     1
#define DEUX   2
#define TROIS  3
#define QUATRE 4
#define CINQ   5

#define DIM1   1
#define DIM2   2
  
#define NBBIN_IMG 256 


//>PARAMETERS_SEG
//===============
#define NB_MOY_COUL      1
#define NB_MOY_GRAD      1

#define NB_GRADBINS      10   
#define SIZEW_HIGRD      7
#define NB_DIVCOLHISTO   4    
#define SIZEW_HISTO      7

#define SIZEW_GRAPH     15      
#define SCALE_SEG       16      

#define NBITSEG_GRAD   100 
#define NBITSEG_METR   300
#define STEPGRADSEG      0.00002 
#define TEMPSEG_INIT   200.0      
#define TEMPSEG_FINAL    1.0
#define RADIUS_SEG      10

#define SZW_INTSEG       5
#define H_INTSEG         0.1

#define NBCLASS          11 
#define REGULSEG         0.40
#define SIZE_SEG         320       


//------------------------------------------------
// CLASSE DISPLAYHYPER -----------------------------
//------------------------------------------------
class MD2S
{
  //--Donnees--
  //-----------
  public:

  //>MtxResult
  float***  Imag1;
  float***  Imag2;
  float***  Imag3;
  float***  Imag4;
  float***  Imag5;

  //>Gradient
  float**** MatxGrd;


  //====================
  //>SEG
  //====================
  int   length,width; //IMG dim

  int   Method;     
  int   SzW;       
  float StGr;       
  int   NbInit;     
  int   NbIter;     
  float StGrInit;   
  int   NbIterFinal; 
  float NrjImg,NrjImgInit;
  float RegulSeg;
  int   NbClass;


  //>Flag
  int  flag_save;
  int  flag_visu;

  //>Utile
  char Name_Img[NCHAR];
  char Extension[NCHAR];  
  
  public:
  MD2S(int,int,int);    
  ~MD2S();
  void MD2S_SEG();

 //=================================
 // SEG :: File>f_MD2S_2.cc
 //=================================

 //GESTION
 //--------
 void  SEG_CreateImgCoul(float**,float**,float**,int,int,float***);
 void  SEG_Moy(float****,int,int,int,int,float***);
 void  SEG_InitAleat(float**,int,int);
 void  SEG_Decimate(float**,int,int,float**,int,int);
 float SEG_DiffMat(float**,float**,int,int,float);

 //>MODEL <DIM>
 //------------
 void SEG_ComputeMultiresNonLocalGraphWindow(float***,int,int,int,int,short int***,int,int,int);
 void SEG_ComputeTextFeat(float***,int,int,float***,int,int,int);

 //>INTERPOLATION <DIM>
 //-------------------
 void  SEG_Interpolate(float***,int,int,int,int,float**,int,int,float**,int,int,int,float);
 void  SEG_Interpolate(float***,int,int,int,int,float***,int,int,float***,int,int,int,float,int);

 //>OPTIMISATION <DIM>
 //------------------
 void  SEG_MultiResOptimizationDim(float***,float***,int,int,int,int,int,int,float***,int,int,int,int);
 void  SEG_MultiResOptimizDim(float***,float***,int,int,int,int,int,int,float***,int,int,int);
 void  SEG_GGMRFDerive(float**,float**,int,int,short int***,int);
 float SEG_ComputeNrjDim(float***,int,int,int,short int***,int);
 float SEG_ComputeBetaDim(float***,float***,int,int,int);
 void  SEG_ConjGradDescDim(float***,float***,int,int,int,short int***,int,int);
 float SEG_ComputeLocNrjDim(float***,int,int,int,float*,int,int,short int***,int);
 void  SEG_SimulatedAnnealingDim(float***,float***,int,int,int,short int***,int,int,float,float);

 //>CLUSTERING
 //-----------
 void SEG_SegmentationCOLORKmeanFast(float***,float**,int,int,int,int,int,float**,float);
 void SEG_SegmentationCOLORKmeanFast(float***,float**,int,int,int,int,int);
 void SEG_ComputeColGradMap(float***,float**,int,int,int);
 void SEG_ComputeColGradMap2(float***,float**,int,int,int);
 void SEG_Paint(float**,float**,int,int,int,int,int);
 void SEG_Paint(float**,int**,int,int,int,int,int);
 void SEG_ConvertCertainClassRegionInf(float**,int,int);
 void SEG_ContrainWithSeg(float**,int,int,float**);
 int  SEG_Identical(int*,int**,int,int);
 void SEG_KmeanFast(int**,int,int,int,int*,int,int);
 void SEG_KmeanFast(int**,int,int,int,int*,int,int,float**,int,int,float);
 void SEG_ConvertClassRegion(float**,int,int);
 int  SEG_FuseSmallRegions(float**,int,int,int*,int,float);

 //>NETTOIE
 //--------
 void SEG_MedianFilter(float**,int,int,int);
 void SEG_AddContourImg(float**,float***,int,int,int);  
};

#endif 
