//---------------------------------------------------
// module  : f_MD2S.cc                       
// auteur  : Max Mignotte                            
// date    :                                              
// langage : C++                                      
// labo    :                                  
//---------------------------------------------------

//-----------------------------------------------
// FICHIERS INCLUS ------------------------------
//-----------------------------------------------
#include "MD2S.h"

//------------------------------------------------
// METHODES DE LA CLASSE DISPLAYHYPER  -------------
//------------------------------------------------
//----------------------------------------------------------
// Constructeur de la classe MD2S
//    <SEGMENTATION IMAGES>
//----------------------------------------------------------
MD2S::MD2S(int lgth,int wdth,int Flg)           
 {
  //Initialisation 
  printf(" >>>>[SEG:%d]",Flg);
  length=lgth;
  width=wdth;

  //Allocation Memoire Matrice  
  Imag1=fmatrix_allocate_3d(TROIS,length,width);
  Imag2=fmatrix_allocate_3d(TROIS,length,width);
  Imag3=fmatrix_allocate_3d(TROIS,length,width);
  Imag4=fmatrix_allocate_3d(TROIS,length,width);
  Imag5=fmatrix_allocate_3d(TROIS,length,width);

  //>Gradient
  MatxGrd=fmatrix_allocate_4d(10,TROIS,length,width);
 }

//----------------------------------------------------------
// Destructeur de la classe MD2S
//----------------------------------------------------------
MD2S::~MD2S()
{ 
  //Libere Memoire Matrice 
  if (Imag1)  free_fmatrix_3d(Imag1,TROIS);
  if (Imag2)  free_fmatrix_3d(Imag2,TROIS);
  if (Imag3)  free_fmatrix_3d(Imag3,TROIS); 
  if (Imag4)  free_fmatrix_3d(Imag4,TROIS); 
  if (Imag5)  free_fmatrix_3d(Imag5,TROIS); 
}

//___________________________________
//___________________________________
//______SEGMENTATION IMAGE___________
//___________________________________
//----------------------------------------------------------
// Segmentation
//----------------------------------------------------------    
void MD2S::MD2S_SEG()
{
  int k,l;
  int NbRegions;
  char MyBuff[200];
  char MyBuffCont[200];

  //Record
  //======
  strcpy(MyBuff,Name_Img);
  strcat(MyBuff,Extension); 

  //>Cst
  #define NB_FEATCOL (NB_DIVCOLHISTO-1)*CARRE(NB_DIVCOLHISTO)  
  #define NB_FEATURES NB_FEATCOL+(4*NB_GRADBINS)
  StGr=STEPGRADSEG;
      
  //>Information
  //============
  printf("\n ---------------------------------------------");
  printf("\n Image : [%s]",Name_Img);
  printf("\n Ext   : [%s]",Extension);
  printf("\n Size  : [lgth:%d | wdth:%d]",length,width);
  printf("\n ---------------------------------------------");
  printf("\n Features[%d]-[%d]",NB_FEATCOL,NB_FEATURES-NB_FEATCOL);
  printf("\n ---------------------------------------------");
  printf("\n NbClass : [%d]",NbClass);
  printf("\n Regul   : [%.3f]",RegulSeg); 
  printf("\n ---------------------------");
  printf("\n FlagVisu: [%d]",flag_visu);
  printf("\n ---------------------------");
  printf("\n");
  fflush(stdout);

  //>Load
  //=====
  printf("\n Chargement Image...");
  load_image_ppm(Name_Img,Imag1,length,width);
  CopyMat(Imag2,Imag1,length,width,TROIS);
  CopyMat(Imag5,Imag1,length,width,TROIS);


  //>AllocationMemoire
  //==================
  float*** MatxText=fmatrix_allocate_3d(NB_FEATURES,length,width);

  float**** TabImgRed=fmatrix_allocate_4d(100,TROIS,length/SCALE_SEG,width/SCALE_SEG);
  float*** ImgRed1=fmatrix_allocate_3d(TROIS,length/SCALE_SEG,width/SCALE_SEG);
  float*** ImgRed2=fmatrix_allocate_3d(TROIS,length/SCALE_SEG,width/SCALE_SEG);
  float*** ImgRed3=fmatrix_allocate_3d(TROIS,length/SCALE_SEG,width/SCALE_SEG);

  float*** Img1=fmatrix_allocate_3d(TROIS,length,width);
  float*** Img2=fmatrix_allocate_3d(TROIS,length,width);
  float*** Img3=fmatrix_allocate_3d(TROIS,length,width);
  float*** Img4=fmatrix_allocate_3d(TROIS,length,width);

  float** ImgPot=fmatrix_allocate_2d(length,width);
  float** ImgSeg=fmatrix_allocate_2d(length,width);
 
  //========================
  //>Compute Matrice Texture
  //========================
  SEG_ComputeTextFeat(Imag2,length,width,MatxText,NB_DIVCOLHISTO,SIZEW_HISTO,SIZEW_HIGRD);
 
  //=====================================================
  //>COLOR/GRADIENT  Reduction [Scale::SCALE_SEG]
  //=====================================================  
    for(k=0;k<NB_MOY_COUL;k++)  
      { printf("\n\n\n  <<<%d>>>",k);
        for(l=0;l<DEUX;l++) SEG_InitAleat(ImgRed1[l],length/SCALE_SEG,width/SCALE_SEG); 
        SEG_MultiResOptimizationDim(ImgRed1,MatxText,length,width,CARRE(SIZEW_GRAPH),SIZEW_GRAPH,0,NB_FEATCOL,ImgRed1,DIM2,SCALE_SEG,NBITSEG_GRAD,NBITSEG_METR);
        CopyMat(TabImgRed[k],ImgRed1,length/SCALE_SEG,width/SCALE_SEG,DIM2);
        SEG_Moy(TabImgRed,length/SCALE_SEG,width/SCALE_SEG,DIM2,NB_MOY_COUL,ImgRed1); }
  
    SEG_Interpolate(MatxText,length,width,0,NB_FEATCOL,ImgRed1,length/SCALE_SEG,width/SCALE_SEG,Img1,length,width,SZW_INTSEG,H_INTSEG,DIM2);

    for(k=0;k<NB_MOY_GRAD;k++)  
        { printf("\n\n\n  <<<%d>>>",k);
          for(l=0;l<1;l++) SEG_InitAleat(ImgRed2[l],length/SCALE_SEG,width/SCALE_SEG); 
          SEG_MultiResOptimizationDim(ImgRed2,MatxText,length,width,CARRE(SIZEW_GRAPH),SIZEW_GRAPH,NB_FEATCOL,NB_FEATURES,ImgRed2,DIM1,SCALE_SEG,NBITSEG_GRAD,NBITSEG_METR);
          CopyMat(TabImgRed[k],ImgRed2,length/SCALE_SEG,width/SCALE_SEG,DIM1);
          SEG_Moy(TabImgRed,length/SCALE_SEG,width/SCALE_SEG,DIM1,NB_MOY_GRAD,ImgRed2); }

    SEG_Interpolate(MatxText,length,width,NB_FEATCOL,NB_FEATURES,ImgRed2,length/SCALE_SEG,width/SCALE_SEG,Img2,length,width,SZW_INTSEG,H_INTSEG,DIM1);

    SEG_CreateImgCoul(ImgRed1[0],ImgRed1[1],ImgRed2[0],length/SCALE_SEG,width/SCALE_SEG,ImgRed3);
    SEG_CreateImgCoul(Img1[0],Img1[1],Img2[0],length,width,Img3);
   //=End===SCALE_SEG=====================================

  
   //=====================================================
   //>COLOR/GRADIENT  Reduction [Scale::0]
   //=====================================================
    SEG_MultiResOptimizDim(Img1,MatxText,length,width,100,16,0,NB_FEATCOL,Img1,DIM2,1,110);
    SEG_MultiResOptimizDim(Img2,MatxText,length,width,100,16,NB_FEATCOL,NB_FEATURES,Img2,DIM1,1,110);
    SEG_CreateImgCoul(Img1[0],Img1[1],Img2[0],length,width,Img3);
    Recal(Img3,length,width);
    CopyMat(Imag3,Img3,length,width,TROIS);
   //=End===SCALE_0======================================

   //>DEBUG
    if (0)
      { SaveImagePpm("","SauveImg3","",Img3,length,width); 
        exit(-1); }

   //=====================================================
   //>CLUSTERING >0.78343
   //=====================================================
    SEG_ComputeColGradMap(Img3,ImgPot,length,width,2);      
    //SEG_SegmentationCOLORKmeanFast(Img3,ImgSeg,length,width,11,5,0,ImgPot,0.40); 
    SEG_SegmentationCOLORKmeanFast(Img3,ImgSeg,length,width,NbClass,5,0,ImgPot,RegulSeg);  
  
   //=====================================================
   //>NETTOYAGE
   //=====================================================
    for(k=0;k<4;k++) if (!SEG_FuseSmallRegions(ImgSeg,length,width,&NbRegions,SIZE_SEG,0.32))  break;   
    for(k=0;k<3;k++) SEG_MedianFilter(ImgSeg,length,width,5);
    for(k=0;k<4;k++) if (!SEG_FuseSmallRegions(ImgSeg,length,width,&NbRegions,SIZE_SEG,0.32))  break;
      
    //=====================================================
    //>FINAL
    //=====================================================
    SEG_ConvertClassRegion(ImgSeg,length,width);
    Recal(ImgSeg,length,width);

    //AddContourImg
    strcpy(MyBuffCont,MyBuff);
    strcat(MyBuffCont,"_CONT");
    SEG_AddContourImg(ImgSeg,Imag5,length,width,3); 
    SaveImagePpm(MyBuffCont,"","",Imag5,length,width);

    //>DEBUG
    if (0)
      { SaveImagePgm("SauveImgPot","",ImgPot,length,width);
        SaveImagePgm("SauveImgSeg","",ImgSeg,length,width); 
        exit(-1); }

   //=====================================================
   //>SAUVEGARDE
   //=====================================================
    for(k=0;k<TROIS;k++) CopyMat(Imag4[k],ImgSeg,length,width);
    SaveImagePgm(MyBuff,"",ImgSeg,length,width);

  //>Liberation Memoire
  //===================
  if (MatxText)  free_fmatrix_3d(MatxText,NB_FEATURES);

  if (TabImgRed) free_fmatrix_4d(TabImgRed,10,TROIS); 
  if (ImgRed1)   free_fmatrix_3d(ImgRed1,TROIS); 
  if (ImgRed2)   free_fmatrix_3d(ImgRed2,TROIS); 
  if (ImgRed3)   free_fmatrix_3d(ImgRed3,TROIS);

  if (Img1)   free_fmatrix_3d(Img1,TROIS);
  if (Img2)   free_fmatrix_3d(Img2,TROIS);
  if (Img3)   free_fmatrix_3d(Img3,TROIS);
  if (Img4)   free_fmatrix_3d(Img4,TROIS);
  if (ImgPot) free_fmatrix_2d(ImgPot);
  if (ImgSeg) free_fmatrix_2d(ImgSeg);
}
