//---------------------------------------------------
// module  : f_MD2S_2.cc                       
// auteur  : Max Mignotte                            
// date    :                                              
// langage : C++                                      
// labo    :                                  
//---------------------------------------------------
//
//________________
//_____ SEG ______
//________________
//________________
//-----------------------------------------------
// FICHIERS INCLUS ------------------------------
//-----------------------------------------------
#include "MD2S.h"


//-----------------------------------------------
//-----------------------------------------------
// GESTION --------------------------------------
//-----------------------------------------------
//-----------------------------------------------
//----------------------------------------------------------
// SEG >> SEG_CreateImgCoul
//---------------------------------------------------------- 
void MD2S::SEG_CreateImgCoul(float** Img0,float** Img1,float** Img2,int lgth,int wdth,float*** ImgOut)
{
 int i,j;

 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) ImgOut[0][i][j]=Img0[i][j];
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) ImgOut[1][i][j]=Img1[i][j];
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) ImgOut[2][i][j]=Img2[i][j];
}

//----------------------------------------------------------
// SEG >> SEG_Moy
//---------------------------------------------------------- 
void MD2S::SEG_Moy(float**** TabImg,int lgth,int wdth,int dpth,int nb,float*** ImgRes)
{
  int i,j,k,l;

 //Init
 for(k=0;k<dpth;k++) for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) ImgRes[k][i][j]=0.0; 

 //>Boucle
  for(l=0;l<nb;l++)   for(k=0;k<dpth;k++) 
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)  
    ImgRes[k][i][j]+=TabImg[l][k][i][j];

 //>Norm
 for(l=0;l<nb;l++)   for(k=0;k<dpth;k++) 
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    ImgRes[k][i][j]/=nb;
}

//----------------------------------------------------------
// SEG >> SEG_InitAleat
//---------------------------------------------------------- 
void MD2S::SEG_InitAleat(float** Img,int lgth,int wdth)
{
 int i,j;

 //>Boucle
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)  
    Img[i][j]=(int)(randomize()*(NBBIN_IMG-1)); 
}

//----------------------------------------------------------
// SEG >> SEG_Decimate
//---------------------------------------------------------- 
void MD2S::SEG_Decimate(float** ImgIn,int lgthIn,int wdthIn,float** ImgOut,int lgthOut,int wdthOut)
{
 int i,j;
 int scale;
 int scale2;

 //>Scale
 scale=(int)(lgthIn/lgthOut);
 scale2=(int)(wdthIn/wdthOut);

 //>Boucle
 for(i=0;i<lgthOut;i++) for(j=0;j<wdthOut;j++)
 ImgOut[i][j]=ImgIn[i*scale][j*scale];
}

//----------------------------------------------------------
// calcule le nombre de differences a chaque iteration
//----------------------------------------------------------
float MD2S::SEG_DiffMat(float** pmatl1,float** pmatl2,int lgth,int wdth,float precs)
{
 int i,j;
 float chg;

 //>Compte NbChgt
 chg=0.0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) if (fabs(pmatl1[i][j]-pmatl2[i][j])>precs) chg++; 
 chg/=(lgth*wdth);
 chg*=100.0;
       
 return chg;
}

//=========================================================================
//=========================================================================
//>MODELE <DIM> ===========================================================
//=========================================================================
//=========================================================================
//-----------------------------------------------
//-----------------------------------------------
// NONLOCALGRPH ---------------------------------
//-----------------------------------------------
//-----------------------------------------------
//----------------------------------------------------------
// SEG >> SEG_ComputeTextFeat
//----------------------------------------------------------
//
//  Output>MatxText[NB_FEAT][lgth][wdth]
//                  NB_FEAT=(div*div*div)+(25*4)
//
//----------------------------------------------------------     
void MD2S::SEG_ComputeTextFeat(float*** img,int lgth,int wdth,float*** MatxText,int div,int SzW,int SzWH)
{
  int i,j,k,l;
  int posr,posc;
  int NbParamColorHisto,NbParamFin;
  float cpt; 
  float lab;
  float divis;
  float divisL; //MODIF::LAB

  //Init. Parametres
  //NbParamColorHisto=div*div*div;
  NbParamColorHisto=div*div*(div-1); //MODIF::LAB
  NbParamFin=NbParamColorHisto+(4*NB_GRADBINS);; 
  divis=(256.0/(float)div);
  divisL=(256.0/(float)(div-1)); //MODIF::LAB
  //divisL=(256.0/(float)div);

  //Presentation
  printf("\n >> Calcul Texture Features [Length:Width:%d:%d]",lgth,wdth);
  printf("[Div=%d][SzW=%d][SzWH=%d]",div,SzW,SzWH);
  fflush(stdout);
  
  //Init. Memoire
  float***  SquWin=fmatrix_allocate_3d(QUATRE,SzW,SzW);
  float***  SquWinH=fmatrix_allocate_3d(QUATRE,SzWH,SzWH);
  float**   MatxNB=fmatrix_allocate_2d(lgth,wdth);
  float**   MatxHor=fmatrix_allocate_2d(lgth,wdth);
  float**   MatxVer=fmatrix_allocate_2d(lgth,wdth);
  float**   MatxDgd=fmatrix_allocate_2d(lgth,wdth);
  float**   MatxDgg=fmatrix_allocate_2d(lgth,wdth);
  float***  ImgLAB=fmatrix_allocate_3d(TROIS,lgth,wdth);

  //Init. Matrix    
  for(k=0;k<NbParamFin;k++) for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) MatxText[k][i][j]=0.0;
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
     MatxNB[i][j]=(0.33*img[0][i][j])+(0.33*img[1][i][j])+(0.33*img[2][i][j]);

  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    { MatxHor[i][j]=0.0;
      MatxVer[i][j]=0.0;
      MatxDgg[i][j]=0.0; 
      MatxDgg[i][j]=0.0; }

  for(i=1;i<(lgth-1);i++) for(j=1;j<(wdth-1);j++) MatxHor[i][j]=fabs(MatxNB[i][j-1]-MatxNB[i][j+1]);
  for(i=1;i<(lgth-1);i++) for(j=1;j<(wdth-1);j++) MatxVer[i][j]=fabs(MatxNB[i-1][j]-MatxNB[i+1][j]);
  for(i=1;i<(lgth-1);i++) for(j=1;j<(wdth-1);j++) MatxDgg[i][j]=fabs(MatxNB[i-1][j-1]-MatxNB[i+1][j+1]);
  for(i=1;i<(lgth-1);i++) for(j=1;j<(wdth-1);j++) MatxDgg[i][j]=fabs(MatxNB[i-1][j+1]-MatxNB[i+1][j-1]);

  //Conversion RGB=>LAB
  ConvertImgRGBToLAB(img,ImgLAB,lgth,wdth);
  for(k=0;k<TROIS;k++) for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) img[k][i][j]=ImgLAB[k][i][j];
  for(k=0;k<TROIS;k++) Recal(img[k],lgth,wdth);

 //=============================================================

      //------------------------------------
      //--- FEATURES COLOR HISTO -----------
      //------------------------------------
      for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)  
        {
         for(k=0;k<SzW;k++) for(l=0;l<SzW;l++) 
            { posr=i-(SzW/2)+k;
              posc=j-(SzW/2)+l;

              if (posr<0)           posr+=lgth;
              if (posr>(lgth-1))    posr-=lgth;  
              if (posc<0)           posc+=wdth;
              if (posc>(wdth-1))    posc-=wdth;

              SquWin[0][k][l]=img[0][posr][posc];
              SquWin[1][k][l]=img[1][posr][posc];
              SquWin[2][k][l]=img[2][posr][posc]; }
   
         //for(k=0;k<SzW;k++) for(l=0;l<SzW;l++)  
	 //   { lab=((int)(SquWin[0][k][l]/divis))*(div*div);
         //     lab+=((int)(SquWin[1][k][l]/divis))*(div);  
         //     lab+=((int)(SquWin[2][k][l]/divis));

         //MODIF::LAB
         for(k=0;k<SzW;k++) for(l=0;l<SzW;l++)  
	    { lab=((int)(SquWin[0][k][l]/divisL))*(div*div);
              lab+=((int)(SquWin[1][k][l]/divis))*(div);  
              lab+=((int)(SquWin[2][k][l]/divis));
 
              //printf("[lab=%d::%.0f::%.0f::%.0f]",lab,SquWin[0][k][l],SquWin[1][k][l],SquWin[2][k][l]);
              //fflush(stdout);
   
              MatxText[(int)(lab)][i][j]++; }

        //for(k=0;k<NbParamColorHisto;k++) MatxText[k][i][j]/=(SzW*SzW);
	}//-End-Features-Color-Histo--------
           

      //------------------------------------
      //--- FEATURES GRAD HISTO ------------
      //------------------------------------
      cpt=0.0;
       for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)  
        {
         for(k=0;k<SzWH;k++) for(l=0;l<SzWH;l++) 
            { posr=i-(SzWH/2)+k;
              posc=j-(SzWH/2)+l;

              if (posr<0)           posr+=lgth;
              if (posr>(lgth-1))    posr-=lgth;  
              if (posc<0)           posc+=wdth;
              if (posc>(wdth-1))    posc-=wdth;

              SquWinH[0][k][l]=MatxHor[posr][posc]; 
              SquWinH[1][k][l]=MatxVer[posr][posc];        
              SquWinH[2][k][l]=MatxDgd[posr][posc];       
              SquWinH[3][k][l]=MatxDgg[posr][posc];  }

              for(k=0;k<SzWH;k++) for(l=0;l<SzWH;l++)  
	        { lab=SquWinH[0][k][l]+0.5;
                  if (lab>NB_GRADBINS) { lab=NB_GRADBINS; cpt++; }
                  MatxText[NbParamColorHisto+(int)(lab)][i][j]++; }

              for(k=0;k<SzWH;k++) for(l=0;l<SzWH;l++)  
	        { lab=SquWinH[1][k][l]+0.5;
                  if (lab>NB_GRADBINS) {  lab=NB_GRADBINS; cpt++; } 
                  MatxText[NbParamColorHisto+NB_GRADBINS+(int)(lab)][i][j]++; }

              for(k=0;k<SzWH;k++) for(l=0;l<SzWH;l++)  
	        { lab=SquWinH[2][k][l]+0.5;
                  if (lab>NB_GRADBINS) { lab=NB_GRADBINS; cpt++; } 
                  MatxText[NbParamColorHisto+(2*NB_GRADBINS)+(int)(lab)][i][j]++; }

              for(k=0;k<SzWH;k++) for(l=0;l<SzWH;l++)  
	        { lab=SquWinH[2][k][l]+0.5;
                  if (lab>NB_GRADBINS) { lab=NB_GRADBINS; cpt++; } 
                  MatxText[NbParamColorHisto+(3*NB_GRADBINS)+(int)(lab)][i][j]++; }

        //for(k=NbParamColorHisto;k<NbParamFin;k++) MatxText[k][i][j]/=(SzWH*SzWH);
        }//-End-Features-Grad-Histo-------- 

  //---------
  //__INFO___
  //---------
  cpt=100*cpt/(4*CARRE(SzWH)*lgth*wdth);
  printf("\n    [%.2f/100 Gradient>%d]\n",cpt,NB_GRADBINS);
  fflush(stdout);

  //===========================================================

  //Liberation Memoire
  if (SquWin)  free_fmatrix_3d(SquWin,QUATRE);
  if (SquWinH) free_fmatrix_3d(SquWinH,QUATRE);
  if (MatxNB)  free_fmatrix_2d(MatxNB);
  if (MatxHor) free_fmatrix_2d(MatxHor);
  if (MatxVer) free_fmatrix_2d(MatxVer);
  if (MatxDgd) free_fmatrix_2d(MatxDgd);
  if (MatxDgg) free_fmatrix_2d(MatxDgg);
  if (ImgLAB)  free_fmatrix_3d(ImgLAB,TROIS);
 }

//--------------------------------------------------------------
// SEG >> ComputeMultiresNonLocalGraphWindow
//--------------------------------------------------------------
//
//  In :: float*** MatxText[NbFeat][lgth][wdth]
// Out :: float*** NonLocGrph[NbCnx][lgth/scale][wdth/scale]
//
//  <<<<NRJ>>>>
//  NonLocGrph[2][][] :: dist :: Beta^2
//                    :: SQUARE (Distance Euclid.) DISTANCE=1
//                    :: SQUARE (Distance Bhatta)  DISTANCE=0
//  <<<<NRJ>>>>
//
//--------------------------------------------------------------     
void MD2S::SEG_ComputeMultiresNonLocalGraphWindow(float*** MatxText,int BegFeat,int EndFeat,\
int lgth,int wdth,short int*** NonLocGrph,int SzW,int NbCnx,int Scale)
{
 short int i,j,k,l,m;
 short int posc,posr;
 short int SzWdiv2;
 float echdiv;
 int Eechdiv;
 float dist;
 int cpt,nb;
 float NbFeat;
 float dmin,dmax;
 float Sum1,Sum2;

 //Constante[0::Bhatta 1::Euclidean]
 const int DISTANCE=0;

 //Connexion Graph
 echdiv=CARRE(SzW)/(float)NbCnx;
 echdiv=(int)(echdiv+0.4999);
 Eechdiv=(int)echdiv;
 SzWdiv2=(SzW/2); 
 NbFeat=EndFeat-BegFeat;

 //Presentation
 printf("\n");  
 if (DISTANCE)  printf("\n  > Compute NonLocalGraph Window (NormeL2) ");
 if (!DISTANCE) printf("\n  > Compute NonLocalGraph Window (Bhatta) ");
 printf("\n  >>> Scale_    ::[%d]",Scale);
 printf("\n  >>> Matx_Text ::[Begin_%d::End_%d][lgthR:%d-wdthR:%d]",BegFeat,EndFeat,lgth,wdth);
 printf("\n  >>> Window_Sz ::[%d]  Connect.::[%d] <Ecart:%d>",SzW,NbCnx,(int)echdiv);
 fflush(stdout);

 //Init_NonLocGrph 
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) for(k=0;k<NbCnx;k++)
   { NonLocGrph[0][k][(i*wdth)+j]=i;
     NonLocGrph[1][k][(i*wdth)+j]=j;
     NonLocGrph[2][k][(i*wdth)+j]=0; }

  //-----------------------------------------------
  //--NonLocal Graph ------------------------------
  //-----------------------------------------------
 dmax=0.0;
 dmin=BIGNUMBER;
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
     {
      //>SearchInBigWindow[posr,posc]
      cpt=0; nb=0;
      for(k=0;k<SzW;k++) for(l=0;l<SzW;l++) 
        { 
          cpt++;
          if (cpt%Eechdiv) continue;

          posr=i-(SzWdiv2)+k;
          posc=j-(SzWdiv2)+l;
          if (posr<0)         posr+=lgth;
          if (posr>(lgth-1))  posr-=lgth; 
          if (posc<0)         posc+=wdth;
          if (posc>(wdth-1))  posc-=wdth;
 
          //>Euclidean Distance 
          //===================         
          if (DISTANCE)
	     { for(dist=0.0,m=BegFeat;m<EndFeat;m++) 
	       dist+=CARRE(MatxText[m][i*Scale][j*Scale]-MatxText[m][posr*Scale][posc*Scale]); }

          //>Bhattacharta Distance
          //======================
          if (!DISTANCE)
	     { for(Sum1=0.0,Sum2=0.0,m=BegFeat;m<EndFeat;m++) 
	          { Sum1+=MatxText[m][i*Scale][j*Scale];
                    Sum2+=MatxText[m][posr*Scale][posc*Scale]; }

               for(dist=0.0,m=BegFeat;m<EndFeat;m++) 
	       dist+=sqrt(((float)MatxText[m][i*Scale][j*Scale]/Sum1)*((float)MatxText[m][posr*Scale][posc*Scale]/Sum2));

               if (dist>1.0) dist=1.0;
               dist=10000*(1-dist); }  
	    
          //Prior ::::::A TESTER::::::
          if  ((abs(posr-i)+abs(posc-j))<1.5) dist/=2.0;
         
          //dist/=NbFeat;
          if (dist>dmax) dmax=dist;
          if (dist<dmin) dmin=dist;
                        
          //>RecordInGraph
          if (nb>=NbCnx) break;
          NonLocGrph[0][nb][(i*wdth)+j]=posr;
          NonLocGrph[1][nb][(i*wdth)+j]=posc;
	  NonLocGrph[2][nb][(i*wdth)+j]=(int)dist;
          nb++;       
	}
     }//-End-NonLocal-Grph---------------------------

  //---------
  //__INFO___
  //---------
  printf(" [ValMin=%.1f::ValMax=%.1f]",dmin,dmax);
  fflush(stdout);
}

//=========================================================================
//=========================================================================
//>INTERPOLATION <DIM> ====================================================
//=========================================================================
//=========================================================================
//----------------------------------------------------------
// SEG_Interpolate 
//----------------------------------------------------------
//
//  ImgUp [lgthUp*wdthUp] >>  ImgBl [lgthBl*wdthBl]
//
//  Using> float*** TextCub [DpthBeg::DpthEnd][lgth][wdth] (CubeTexture)
//  Using> Buades
//
//  Nota1: ImgUp in [0.0::255] ou in [0.0::1.0]
//              
//----------------------------------------------------------
void MD2S::SEG_Interpolate(float*** TextCub,int lgth,int wdth,int DpthBeg,int DpthEnd,\
float** ImgUp,int lgthUp,int wdthUp,float** ImgBl,int lgthBl,int wdthBl,int SizeW,float h)
{ 
 int i,j,k,l,m;
 int posr,posc,pposr,pposc; 
 int rowEnt,colEnt; 
 int Scale,Scale3,Scale2;
 int cpt;
 double dist,den,min;
 int Dpth;
 
 //parametre
 Scale=lgthBl/lgthUp;
 Scale3=lgth/lgthBl;
 Scale2=lgth/lgthUp;
 Dpth=DpthEnd-DpthBeg;

 //Presentation
 printf("\n    SEG_Interpolation [%d::%d]",lgth,wdth);
 printf(" <Sc1=%d :: Sc3=%d>",Scale,Scale3);
 printf(" <SzW=%d>",SizeW);
 fflush(stdout);

 //AllocationMemoire
 float*  VctIn=fmatrix_allocate_1d(Dpth);
 float*  VctOu=fmatrix_allocate_1d(Dpth);
 double** Val=dmatrix_allocate_2d(CINQ,SizeW*SizeW);

 //Init ImgBl (below) from ImgUp
 for(i=0;i<lgthBl;i++) for(j=0;j<wdthBl;j++) ImgBl[i][j]=0.0;

 for(i=0;i<lgthBl;i++) for(j=0;j<wdthBl;j++)
 if ((!(i%Scale))&&(!(j%Scale))) if (((i/Scale)<lgthUp)&&((j/Scale)<wdthUp))  
 ImgBl[i][j]=ImgUp[i/Scale][j/Scale];

 //=======================================================    
 //Boucle
 //=======================================================
 for(i=0;i<lgthBl;i++) for(j=0;j<wdthBl;j++) if (!ImgBl[i][j])
   {
    //>Recup VctIn
    for(m=DpthBeg;m<DpthEnd;m++) VctIn[m-DpthBeg]=TextCub[m][i*Scale3][j*Scale3]; //>Img[lgth,wdth]

     //>Recup[LevelGrey_Pixels\in.Spat.Vois.]_ImgUp
     rowEnt=(int)i/Scale; 
     colEnt=(int)j/Scale; //>ImgUp
     cpt=0;
     for(k=0;k<SizeW;k++) for(l=0;l<SizeW;l++) 
        { 
         posr=rowEnt-(SizeW/2)+k;
         posc=colEnt-(SizeW/2)+l;
          if (posr<0)           posr+=lgthUp;
          if (posr>(lgthUp-1))  posr-=lgthUp; 
          if (posc<0)           posc+=wdthUp;
          if (posc>(wdthUp-1))  posc-=wdthUp;

          Val[2][cpt]=ImgUp[posr][posc]; 
           
	  pposr=(posr*Scale2);
	  pposc=(posc*Scale2); //>Img[lgth,wdth]
          for(m=DpthBeg;m<DpthEnd;m++) VctOu[m-DpthBeg]=TextCub[m][pposr][pposc];

          //>CompareWith[Vector\in.Spat.Vois.]_ImgUp
          dist=0.0;
          for(m=0;m<Dpth;m++) dist+=CARRE(VctIn[m]-VctOu[m]);
          dist/=Dpth;
          Val[3][cpt]=exp(-(dist/h));
          Val[4][cpt]=dist; 
          cpt++;                      
	}        

    //>Interpolation <Buades ou ppv>
    //------------------------------
    for(dist=0.0,m=0;m<SizeW*SizeW;m++) dist+=Val[3][m]*Val[2][m];
    for(den=0.0,m=0;m<SizeW*SizeW;m++)  den+=Val[3][m];
    if (den) ImgBl[i][j]=(dist/den);
    else { 
          ImgBl[i][j]=Val[2][0];
          for(min=Val[4][0],m=0;m<SizeW*SizeW;m++) if (Val[4][m]<min) 
                 {  min=Val[4][m];  
		    ImgBl[i][j]=Val[2][m]; } }
   }
 //======================================================

 //LiberationMemoire
 if (VctIn)  free_fmatrix_1d(VctIn);
 if (VctOu)  free_fmatrix_1d(VctOu); 
 if (Val)    free_dmatrix_2d(Val);
}

//----------------------------------------------------------
// SEG_Interpolate 
//----------------------------------------------------------
//              
//----------------------------------------------------------
void MD2S::SEG_Interpolate(float*** TextCub,int lgth,int wdth,int DpthBeg,int DpthEnd,\
float*** ImgUp,int lgthUp,int wdthUp,float*** ImgBl,int lgthBl,int wdthBl,int SizeW,float h,int nbdpth)
{ 
 int k;

 for(k=0;k<nbdpth;k++) 
   SEG_Interpolate(TextCub,lgth,wdth,DpthBeg,DpthEnd,ImgUp[k],lgthUp,wdthUp,ImgBl[k],lgthBl,wdthBl,SizeW,h);
}


//=========================================================================
//=========================================================================
//>OPTIMISATION <DIM> =====================================================
//=========================================================================
//=========================================================================
//------------------------------------------------------------------
// SEG >> MultiResOptimization<DIM> <GRADIENT+SA>
//------------------------------------------------------------------
//
// In  :: float*** Img[lgth][wdth]
// Out :: float** ImgRes[lgth/scale][wdth/scale]
//
//------------------------------------------------------------------     
void MD2S::SEG_MultiResOptimizationDim(float*** ImgIn,float*** MatxText,int lgth,int wdth,int NbCnxGrph,int SzWGrph, \
int dpthBeg,int dpthEnd,float*** ImgRes,int NBDPTH,int Scale,int NbItGrad, int NbItMetr)
{
 int wdth_r,lgth_r;

 //>Parametre
 lgth_r=(int)(lgth/Scale);
 wdth_r=(int)(wdth/Scale);

  //>Presentation
  printf("\n\n ____MultiResolution Optimization__[DIM::%d]___",NBDPTH);
  printf("\n _____________________________________________");
  printf("\n  >> Scale:::::[%d]",Scale);
  printf("\n  >> Img:::::::[L=%d::W=%d]>>[LRed=%d::WRed=%d]",lgth,wdth,lgth_r,wdth_r);
  printf("\n  >> NbFeat::::[%d::%d]",dpthBeg,dpthEnd);
  printf("\n  >> NbCnxGrph:[%d]",NbCnxGrph);
  printf("\n  >> SzWGrph:::[%d]",SzWGrph);
  fflush(stdout);

  //>AllocationMemoire
  short int*** NonLocGrphRed=simatrix_allocate_3d(TROIS,NbCnxGrph,(wdth_r*lgth_r));
  float*** ImgRed=fmatrix_allocate_3d(NBDPTH,lgth_r,wdth_r);

  //>NonLocalMultiResGraph
  SEG_ComputeMultiresNonLocalGraphWindow(MatxText,dpthBeg,dpthEnd,lgth_r,wdth_r,NonLocGrphRed,SzWGrph,NbCnxGrph,Scale);

  //>ImgIn > ImgRed      
  SEG_ConjGradDescDim(ImgIn,ImgRed,NBDPTH,lgth_r,wdth_r,NonLocGrphRed,NbCnxGrph,NbItGrad);           
  SEG_SimulatedAnnealingDim(ImgRed,ImgRes,NBDPTH,lgth_r,wdth_r,NonLocGrphRed,NbCnxGrph,NbItMetr,TEMPSEG_INIT,RADIUS_SEG);     

  //>Liberation Memoire
 if (NonLocGrphRed) free_simatrix_3d(NonLocGrphRed,TROIS);
 if (ImgRed)        free_fmatrix_3d(ImgRed,NBDPTH);
}

//------------------------------------------------------------------
// SEG >> MultiResOptimiz<DIM> <SA> 
//------------------------------------------------------------------
//
// In  :: float*** Img[lgth][wdth]
// Out :: float** ImgRes[lgth/scale][wdth/scale]
//
//------------------------------------------------------------------     
void MD2S::SEG_MultiResOptimizDim(float*** ImgIn,float*** MatxText,int lgth,int wdth,int NbCnxGrph,int SzWGrph, \
int dpthBeg,int dpthEnd,float*** ImgRes,int NBDPTH,int Scale,int NbItMetr)
{
 int wdth_r,lgth_r;

 //>Parametre
 lgth_r=(int)(lgth/Scale);
 wdth_r=(int)(wdth/Scale);

  //>Presentation
  printf("\n\n ____MultiResolution Optimiz__[DIM::%d]___",NBDPTH);
  printf("\n ________________________________________");
  printf("\n  >> Scale:::::[%d]",Scale);
  printf("\n  >> Img:::::::[L=%d::W=%d]>>[LRed=%d::WRed=%d]",lgth,wdth,lgth_r,wdth_r);
  printf("\n  >> NbFeat::::[%d::%d]",dpthBeg,dpthEnd);
  printf("\n  >> NbCnxGrph:[%d]",NbCnxGrph);
  printf("\n  >> SzWGrph:::[%d]",SzWGrph);
  printf("\n  >> NbItMetr::[%d]",NbItMetr);
  fflush(stdout);

  //>AllocationMemoire
  short int*** NonLocGrphRed=simatrix_allocate_3d(TROIS,NbCnxGrph,(wdth_r*lgth_r));
  float*** ImgRed=fmatrix_allocate_3d(NBDPTH,lgth_r,wdth_r);

  //>NonLocalMultiResGraph
  SEG_ComputeMultiresNonLocalGraphWindow(MatxText,dpthBeg,dpthEnd,lgth_r,wdth_r,NonLocGrphRed,SzWGrph,NbCnxGrph,Scale);

  //>ImgIn > ImgRes            
  SEG_SimulatedAnnealingDim(ImgIn,ImgRes,NBDPTH,lgth_r,wdth_r,NonLocGrphRed,NbCnxGrph,NbItMetr,TEMPSEG_INIT,RADIUS_SEG);     

  //>Liberation Memoire
 if (NonLocGrphRed) free_simatrix_3d(NonLocGrphRed,TROIS);
 if (ImgRed)        free_fmatrix_3d(ImgRed,NBDPTH);
}

//-------------------------------------------------------------
// SEG >> SEG_GGMRFDerive
//-------------------------------------------------------------
//
//  <<<<NRJ>>>>
//  DELTA(NRJ) = -4 (Xs-Xt)) * SUM_<st> ( Beta - (Xs-Xt)^2 )
//  <<<<NRJ>>>>
//  
// In  :: short int*** NonLocGrph[TROIS][NbCnx][lgth*wdth]
//     :: Img ...>> Derivate(Img)=ImgGrad
// Out :: ImgGrad[lgth][wdth]
//
//-------------------------------------------------------------     
void MD2S::SEG_GGMRFDerive(float** Img,float** ImgGrad,int lgth,int wdth,short int*** NonLocGrph,int NbCnx)
{
 int i,j,k;
 int posr,posc;
 float tmp;
 float xs,xt;
 float difx;
 int nbp;
 
 //Boucle
 //==================================
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
   {
     nbp=(i*wdth)+j;
     xs=Img[i][j];

     tmp=0.0;
     //>ForAllConnexion
     for(k=0;k<NbCnx;k++)
       { posr=NonLocGrph[0][k][nbp];
         posc=NonLocGrph[1][k][nbp];
         xt=Img[posr][posc];
         difx=(xs-xt);
         tmp+=-4*(NonLocGrph[2][k][nbp]-CARRE(difx))*difx; }

     //>Record
     ImgGrad[i][j]=tmp/(float)NbCnx;
   } 
}

//-----------------------------------------------
//-----------------------------------------------
// GRADIENT/SA <DIM> ----------------------------
//-----------------------------------------------
//-----------------------------------------------
//----------------------------------------------------------
// SEG >> ComputeNrj <Norme L2> 
//----------------------------------------------------------
//
// In  :: Img[NbDpth][lgth][wdth]
//     :: NonLocGrph[TROIS][NbCnx][lgth*wdth]
// Out :: Nrj
//
//  <<<<NRJ>>>>
//  NRJ = SUM_<st> ( Beta - (Xs-Xt)^2 )^2
//  <<<<NRJ>>>>
//
//----------------------------------------------------------     
float MD2S::SEG_ComputeNrjDim(float*** Img,int lgth,int wdth,int NbDpth,short int*** NonLocGrph,int NbCnx)
{
 int i,j,k,l;
 float totvr,TotalVar;
 int posr,posc;
 int nbp;
 float dist;
 float distImg;

 //Variation Totale
 TotalVar=0.0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
     {
      totvr=0.0;
      for(k=0;k<NbCnx;k++)
        { nbp=(i*wdth)+j;
          posr=(int)NonLocGrph[0][k][nbp];
          posc=(int)NonLocGrph[1][k][nbp];
          dist=NonLocGrph[2][k][nbp];

          for(distImg=0.0,l=0;l<NbDpth;l++) distImg+=CARRE(Img[l][i][j]-Img[l][posr][posc]);
          totvr+=CARRE(dist-distImg); }

      TotalVar+=totvr/(float)NbCnx; 
     }

 //Retour
 TotalVar/=(float)(NbDpth);
 return TotalVar/(float)(wdth*lgth);
}

//----------------------------------------------------------
// SEG >> SEG_ComputeBeta
//----------------------------------------------------------
//
//----------------------------------------------------------     
float MD2S::SEG_ComputeBetaDim(float*** ImGrd,float*** ImGrdp,int nbdpth,int lgth,int wdth)
{
 int i,j,l;
 float Num,Denum;

 // Numerateur & Denumerateur
 for(Num=0.0,l=0;l<nbdpth;l++)   for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) Num+=(ImGrd[l][i][j]-ImGrdp[l][i][j])*ImGrd[l][i][j];
 for(Denum=0.0,l=0;l<nbdpth;l++) for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) Denum+=CARRE(ImGrdp[l][i][j]);

 //Retour
 return (Num/Denum);
}

//----------------------------------------------------------
//  SEG >> SEG_ConjGradDescDim
//----------------------------------------------------------
// Descente Gradient Conjugu ([NBDPTH] Dimensions) 
// ---------------------------------------------------------
//
// x[n+1]=x[n]+StGr*d[n]
// 
//  d[n]=- Grad_J(x[n])
//       + <Grad_J(x[n])-Grad_J(x[n-1]),Grad_J(x[n])>/<Grad_J(x[n-1]),Grad_J(x[n-1])> d[n-1]
//
// Img                 : Img Initiale :: Image_Nrj_init
// MatxGrd[8][x]       : Img Initiale :: Image_Nrj_init
// MatxGrd[1][x]       : x[n] puis ...x[n+1]
// MatxGrd[2][x]       : Grad_J(x[n])
// MatxGrd[3][x]       : Grad_J(x[n-1])
// MatxGrd[4][x]       : d[n]
// MatxGrd[5][x]       : d[n-1]
// MatxGrd[9][x]       : x[n+1]
// 
// MatxGrd[7][x]       : ImgInit
//
// ------------------------------
// Img[NbDpth] :: MAX(NbDpth)=3
// ------------------------------
//----------------------------------------------------------    
void MD2S::SEG_ConjGradDescDim(float*** Img,float*** ImgRes,int NBDPTH,int lgth,int wdth, \
short int*** NonLocGrph,int NbCnx,int NbIter)
{
 int k,l;
 float nrj,nrj_prec,nrj_init;
 float Beta;
 int NbDiv;

 //>Verif
 if (NBDPTH>3) { printf("\n NbDpth>3"); exit(-1); }

 //>Init
 for(l=0;l<NBDPTH;l++) CopyMat(MatxGrd[1][l],Img[l],lgth,wdth);
 for(l=0;l<NBDPTH;l++) CopyMat(MatxGrd[8][l],Img[l],lgth,wdth);
 for(l=0;l<NBDPTH;l++) CopyMat(MatxGrd[7][l],Img[l],lgth,wdth);
 nrj=SEG_ComputeNrjDim(MatxGrd[8],lgth,wdth,NBDPTH,NonLocGrph,NbCnx); 
 nrj_prec=nrj;
 nrj_init=nrj;
 printf("\n    >  ConjGradDescenteDim<%d> [L:W:%d:%d][NbCx=%d][StGr=%.3f*10-6]\n",NBDPTH,lgth,wdth,NbCnx,StGr*MILLION);  
 printf("\n    >  <NrjInit=%.1f>",nrj);
 fflush(stdout);
 NrjImgInit=nrj_init;
 Beta=0.0;
 NbDiv=0;

 //>Flag_stop
 int FlagStop=0;
 
 //>Conjugate Gradient Descent <DIM=NBDPTH>
 //========================================
 for(k=0;((k<=NbIter)||(!FlagStop));k++)
   {
     //>Info
     if ((k<20)||(!(k%10))) printf("\n [%d]>  ",k);

     // MatxGrd[2][] <-- Grad_J(x[k])
     for(l=0;l<NBDPTH;l++)  SEG_GGMRFDerive(MatxGrd[1][l],MatxGrd[2][l],lgth,wdth,NonLocGrph,NbCnx);

     //-----------------------
     //> [k==0] SimpleGradient
     //-----------------------
     //      > d[k] <-- Grad_J(x[k])    
     //      > x[k+1]=x[n]-StrGr*Grad_J(x[k]) 
     if (k==0) 
        { for(l=0;l<NBDPTH;l++) CopyMat(MatxGrd[4][l],MatxGrd[2][l],lgth,wdth);
          for(l=0;l<NBDPTH;l++) AddMatrix(MatxGrd[9][l],MatxGrd[1][l],-1.0*StGr,MatxGrd[2][l],lgth,wdth); }
    
     //--------------------------------------------
     // [k!=0] Gradient Conjugue
     //-------------------------------------------- 
     //      > x[k+1]=x[k]-StGr*d[k]
     if (k) 
	{  Beta=SEG_ComputeBetaDim(MatxGrd[2],MatxGrd[3],NBDPTH,lgth,wdth);            
           for(l=0;l<NBDPTH;l++) MultMatrix(MatxGrd[6][l],Beta,MatxGrd[5][l],lgth,wdth);
           for(l=0;l<NBDPTH;l++) AddMatrix(MatxGrd[4][l],MatxGrd[2][l],-1.0,MatxGrd[6][l],lgth,wdth);
           for(l=0;l<NBDPTH;l++) AddMatrix(MatxGrd[9][l],MatxGrd[1][l],-1.0*StGr,MatxGrd[4][l],lgth,wdth); }

      //>Calcul Nrj & Stab(x[k],x[k-1])
      if ((k<20)||(!(k%10)))
         {  nrj_prec=nrj;
	    nrj=SEG_ComputeNrjDim(MatxGrd[9],lgth,wdth,NBDPTH,NonLocGrph,NbCnx); 
            printf("<Nrj=%.1f> <Beta=%.1f*10^-6>",nrj,Beta*MILLION);
            fflush(stdout); }
    
      //>RecordBest
      if ((nrj<nrj_prec)&&(nrj<nrj_init)) for(l=0;l<NBDPTH;l++) CopyMat(MatxGrd[8][l],MatxGrd[9][l],lgth,wdth);
       
      //>Verif si StGr trop grand
      if (k<30)
          if ((nrj>nrj_prec)||(nrj>nrj_init)||(isnan(nrj)))
	     { for(l=0;l<NBDPTH;l++) CopyMat(MatxGrd[9][l],MatxGrd[8][l],lgth,wdth);
               StGr/=2.0;
               NbDiv++;
               for(l=0;l<NBDPTH;l++) InitMatrix(MatxGrd[5][l],lgth,wdth);
               printf(" ! New StGr=%.1f*10^-6",StGr*MILLION);
               k--;
               fflush(stdout); }
      
       // x[k+1] --> x[k]  
       // Img3 <-- Grad_J(x[k-1]) 
       // Img5 <-- d[k-1]
       for(l=0;l<NBDPTH;l++) CopyMat(MatxGrd[1][l],MatxGrd[9][l],lgth,wdth);
       for(l=0;l<NBDPTH;l++) CopyMat(MatxGrd[3][l],MatxGrd[2][l],lgth,wdth);
       for(l=0;l<NBDPTH;l++) CopyMat(MatxGrd[5][l],MatxGrd[4][l],lgth,wdth);

       //End
       if ((k>NbIter)||((NbDiv>6)&&k>10)) break;  

   }//FIN_ALGO======================================
      
 //Enregistrement Nrj_finale[ MatxGrd[9] ] 
 NrjImg=nrj;
 printf("\n      >> [Nrj:%.5f]",NrjImg);
 for(l=0;l<NBDPTH;l++) printf(" [Diff=%.1f]",ComputeDiff(MatxGrd[9][l],MatxGrd[7][l],lgth,wdth));       

 //Transfert>ImgRes
 printf("\n");
 for(l=0;l<NBDPTH;l++) CopyMat(ImgRes[l],MatxGrd[9][l],lgth,wdth);  
}

//----------------------------------------------------------
// SEG >> Compute Local NRJ  
//----------------------------------------------------------
//
// <<<<NRJ>>>>
// NRJ = SUM_<st> ( Beta - (Xs-Xt)^2 )^2
// <<<<NRJ>>>>
//
//---------------------------------------------------------- 
float MD2S::SEG_ComputeLocNrjDim(float*** Img,int nbdpth,int row,int col,float* val,int lgth,int wdth,short int*** NonLocGrph,int NbCnx)
{
 int k,l;
 float totvr;
 int posr,posc;
 int nbp;
 float dist,distImg;

 //Calcul Local NRJ
 //-------------------------
 totvr=0.0;
 nbp=(row*wdth)+col;
 
 for(k=0;k<NbCnx;k++)
    { posr=NonLocGrph[0][k][nbp];
      posc=NonLocGrph[1][k][nbp];
      dist=NonLocGrph[2][k][nbp];
      
      for(distImg=0.0,l=0;l<nbdpth;l++) distImg+=CARRE(val[l]-Img[l][posr][posc]);
      totvr+=CARRE(dist-distImg); }

 totvr/=(float)NbCnx;

 //Retour
 totvr/=(float)nbdpth;
 return totvr;
}

//---------------------------------------------------------
//----------------------------------------------------------
// SEG >> SimulatedAnnealing <DIM>
//----------------------------------------------------------
//
//----------------------------------------------------------    
void MD2S::SEG_SimulatedAnnealingDim(float*** Img,float*** ImgRes,int NBDPTH,int lgth,int wdth,\
short int*** NonLocGrph,int NbCnx,int NbIter,float Temp_Init,float Radius)
{
 int i,j,k,l,m;
 float nrj,nrj1,nrj2;
 float ValImg;
 float rd,rd2; 
 float DeltaNrj;
 float ProbAcc;
 float RadiusDiv2; 
 float nbchgt;

 //>Simulated Annealing
 float Temp_Fina=TEMPSEG_FINAL;
 float Temp,TempInv;
 int   Kmax=NbIter;

 //AllocationMemory
 float* TabVal1=fmatrix_allocate_1d(NBDPTH);
 float* TabVal2=fmatrix_allocate_1d(NBDPTH);

 //>Init
 RadiusDiv2=Radius/2.0;
 SzW=(int)sqrt(NbCnx);
 for(l=0;l<NBDPTH;l++) CopyMat(MatxGrd[1][l],Img[l],lgth,wdth);
 for(l=0;l<NBDPTH;l++) CopyMat(MatxGrd[2][l],Img[l],lgth,wdth);
 nrj=SEG_ComputeNrjDim(MatxGrd[1],lgth,wdth,NBDPTH,NonLocGrph,NbCnx);
 printf("\n\n    >  Simulated Annealing [DIM=%d][NbIterMax=%d][Radius=%.1f]",NBDPTH,NbIter,Radius);  
 printf("\n                             [Temp_Init=%.1f][Temp_Final=%.1f]",Temp_Init,Temp_Fina);
 printf("\n\n    >  <NrjInit=%.2f>",nrj);

  //====================================================================
  //Simulated Annealing -->sur Img 
  //====================================================================
  for(k=0;;k++)
     {
      Temp=Temp_Init*powf((Temp_Fina/Temp_Init),((float)k/Kmax));
      TempInv=1.0/Temp;
      if (Temp<Temp_Fina) break;

      if (!(k%10)) 
      for(l=0;l<NBDPTH;l++) CopyMat(MatxGrd[2][l],MatxGrd[1][l],lgth,wdth);

      //-----------------------------------------------------------
      // Loop Img > Loop Pixels
      //------------------------------------------------------------
          for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) for(l=0;l<NBDPTH;l++)
            {
               //Gibbs Sampling Record
	       ValImg=MatxGrd[1][l][i][j];
  	       rd=ValImg-RadiusDiv2+(Radius*randomize());
 
               if (rd<0.0)   rd=0.0;
               if (rd>255.0) rd=255.0;

	        for(m=0;m<NBDPTH;m++) { TabVal1[m]=MatxGrd[1][m][i][j]; TabVal2[m]=MatxGrd[1][m][i][j]; }
                TabVal2[l]=rd;
 
                nrj1=SEG_ComputeLocNrjDim(MatxGrd[1],NBDPTH,i,j,TabVal1,lgth,wdth,NonLocGrph,NbCnx);
                nrj2=SEG_ComputeLocNrjDim(MatxGrd[1],NBDPTH,i,j,TabVal2,lgth,wdth,NonLocGrph,NbCnx);               
                DeltaNrj=nrj2-nrj1;

                if (DeltaNrj<0) MatxGrd[1][l][i][j]=rd;

                else { ProbAcc=exp(-TempInv*DeltaNrj); 
                       rd2=randomize();
                       if (rd2<ProbAcc)  MatxGrd[1][l][i][j]=rd; }    
           
             }//End_Loop_Pixel------------------------------------------  

          //>Info
          if (!(k%10))
	     { nrj=SEG_ComputeNrjDim(MatxGrd[1],lgth,wdth,NBDPTH,NonLocGrph,NbCnx); 
               nbchgt=SEG_DiffMat(MatxGrd[2][0],MatxGrd[1][0],lgth,wdth,1.0);
               printf("\n  [%d]>%.1f [Temp:%.2f][NbChgt/100=%.2f]",k,nrj,Temp,nbchgt); }

         }//End_Simulated_Annealing==================================================================
  
 //Nrj_finale[Img1] 
 for(l=0;l<NBDPTH;l++) CopyMat(ImgRes[l],MatxGrd[1][l],lgth,wdth);
 nrj=SEG_ComputeNrjDim(ImgRes,lgth,wdth,NBDPTH,NonLocGrph,NbCnx);
 NrjImg=nrj;
 printf("\n   >> [Nrj:%.3f]",nrj); 
 fflush(stdout);

 //FreeMemory
 if (TabVal1) free_fmatrix_1d(TabVal1);
 if (TabVal2) free_fmatrix_1d(TabVal2);
}

//=========================================================================
//=========================================================================
//>CLUSTERING =============================================================
//=========================================================================
//=========================================================================
//----------------------------------------------------------
// SEG >> SEG_SegmentationMCOLORKmeanFast
//----------------------------------------------------------     
// SegmentationCOLORKmean Avec Entier 
//----------------------------------------------------------     
void MD2S::SEG_SegmentationCOLORKmeanFast(float*** img,float** matout,int lgth,int wdth,int NbClass,int SzW,int Seed)
{
 int i,j,k,l;
 int nbpts; 
 int posr,posc;
 int nb;

 //Init
 int NbParam=3*SzW*SzW;   
 
 //Initialisatio memoire
 int** PtsTab=imatrix_allocate_2d(lgth*wdth,NbParam);
 float*** SquWin=fmatrix_allocate_3d(TROIS,SzW,SzW);
 int*  TabLabel=imatrix_allocate_1d(NbParam);
 int* VctLabel=imatrix_allocate_1d(lgth*wdth);  

 //Presentation
 printf("\n   >>> Segmentation-COLOR-Kmean");
 printf("[NbCl:%d][Ws:%d][Par:%d]",NbClass,SzW,NbParam); 
 fflush(stdout);

 //---------------------------------------------------------------
 //Data   
 //----------------------------------------------------------------                       
 nbpts=0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)  
    {
     for(k=0;k<SzW;k++) for(l=0;l<SzW;l++) 
        { 
	 posr=i-(SzW/2)+k;
         posc=j-(SzW/2)+l;

         if (posr<0)           posr+=lgth;
         if (posr>(lgth-1))    posr-=lgth;  
         if (posc<0)           posc+=wdth;
         if (posc>(wdth-1))    posc-=wdth;
        
         SquWin[0][k][l]=img[0][posr][posc];
         SquWin[1][k][l]=img[1][posr][posc];
         SquWin[2][k][l]=img[2][posr][posc]; 
        }

     //DataStructure
     for(k=0;k<NbParam;k++)  TabLabel[k]=0;
      
     nb=0;
     for(k=0;k<SzW;k++) for(l=0;l<SzW;l++)  
       { TabLabel[(3*nb)+0]=(int)SquWin[0][k][l];
         TabLabel[(3*nb)+1]=(int)SquWin[1][k][l];
         TabLabel[(3*nb)+2]=(int)SquWin[2][k][l]; 
         nb++; }
    
     for(k=0;k<NbParam;k++)    PtsTab[nbpts][k]=TabLabel[k];

     nbpts++;     
    }//----------------------------------------------------------------

 //K-Mean    
 SEG_KmeanFast(PtsTab,NbClass,(lgth*wdth),NbParam,VctLabel,Seed,1);  
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)  matout[i][j]=VctLabel[(i*wdth)+j];    

 //Liberation Memoire
 if (PtsTab)         free_imatrix_2d(PtsTab);
 if (SquWin)         free_fmatrix_3d(SquWin,TROIS);
 if (TabLabel)       free_imatrix_1d(TabLabel);
 if (VctLabel)       free_imatrix_1d(VctLabel);
}

//----------------------------------------------------------
// SEG >> SEG_SegmentationMCOLORKmeanFast
//----------------------------------------------------------     
// SegmentationCOLORKmean Avec Entier 
//----------------------------------------------------------     
void MD2S::SEG_SegmentationCOLORKmeanFast(float*** img,float** matout,int lgth,int wdth,int NbClass,\
 int SzW,int Seed,float** Pot,float thresh)
{
 int i,j,k,l;
 int nbpts; 
 int posr,posc;
 int nb;

 //Init
 int NbParam=3*SzW*SzW;   
 
 //Initialisatio memoire
 int** PtsTab=imatrix_allocate_2d(lgth*wdth,NbParam);
 float*** SquWin=fmatrix_allocate_3d(TROIS,SzW,SzW);
 int*  TabLabel=imatrix_allocate_1d(NbParam);
 int* VctLabel=imatrix_allocate_1d(lgth*wdth);  

 //Presentation
 printf("\n   >>> Segmentation-COLOR-Kmean <Constraint>");
 printf("[NbCl:%d][Ws:%d][Par:%d]",NbClass,SzW,NbParam); 
 fflush(stdout);

 //---------------------------------------------------------------
 //Data   
 //----------------------------------------------------------------                       
 nbpts=0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)  
    {
     for(k=0;k<SzW;k++) for(l=0;l<SzW;l++) 
        { 
	 posr=i-(SzW/2)+k;
         posc=j-(SzW/2)+l;

         if (posr<0)           posr+=lgth;
         if (posr>(lgth-1))    posr-=lgth;  
         if (posc<0)           posc+=wdth;
         if (posc>(wdth-1))    posc-=wdth;
        
         SquWin[0][k][l]=img[0][posr][posc];
         SquWin[1][k][l]=img[1][posr][posc];
         SquWin[2][k][l]=img[2][posr][posc]; 
        }

     //DataStructure
     for(k=0;k<NbParam;k++)  TabLabel[k]=0;
      
     nb=0;
     for(k=0;k<SzW;k++) for(l=0;l<SzW;l++)  
       { TabLabel[(3*nb)+0]=(int)SquWin[0][k][l];
         TabLabel[(3*nb)+1]=(int)SquWin[1][k][l];
         TabLabel[(3*nb)+2]=(int)SquWin[2][k][l]; 
         nb++; }
    
     for(k=0;k<NbParam;k++)    PtsTab[nbpts][k]=TabLabel[k];

     nbpts++;     
    }//----------------------------------------------------------------

 //K-Mean    
 SEG_KmeanFast(PtsTab,NbClass,(lgth*wdth),NbParam,VctLabel,Seed,1,Pot,lgth,wdth,thresh);  
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)  matout[i][j]=VctLabel[(i*wdth)+j];    

 //Liberation Memoire
 if (PtsTab)         free_imatrix_2d(PtsTab);
 if (SquWin)         free_fmatrix_3d(SquWin,TROIS);
 if (TabLabel)       free_imatrix_1d(TabLabel);
 if (VctLabel)       free_imatrix_1d(VctLabel);
}

//----------------------------------------------------------
// SEG >> SEG_ComputeColGradMap
//----------------------------------------------------------     
// Carte Gradient Couleur
//----------------------------------------------------------     
void MD2S::SEG_ComputeColGradMap(float*** img,float** matout,int lgth,int wdth,int dist)
{
  int i,j,k;
  int posrA,poscA,posrB,poscB;
  float tmp;

  //Loop
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) matout[i][j]=0.0;

  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    { 
      posrB=i-dist;
      poscB=j-dist;
      posrA=i+dist;
      poscA=j+dist;

      if (posrB<0)        posrB+=lgth;
      if (poscB<0)        poscB+=wdth;
      if (posrA>(lgth-1)) posrA-=lgth;
      if (poscA>(wdth-1)) poscA-=wdth; 

      tmp=0.0;
      for(k=0;k<TROIS;k++) 
	{ tmp+=CARRE(img[k][posrB][j]-img[k][posrA][j])+CARRE(img[k][i][poscB]-img[k][i][poscA]);
          tmp+=CARRE(img[k][posrB][poscA]-img[k][posrA][poscB])+CARRE(img[k][posrB][poscB]-img[k][posrA][poscA]);
        }
      matout[i][j]=sqrt(tmp); }

  //Recal
  Recal(matout,lgth,wdth);
}

//----------------------------------------------------------
// SEG >> SEG_ComputeColGradMap
//----------------------------------------------------------     
// Carte Gradient Couleur
//----------------------------------------------------------     
void MD2S::SEG_ComputeColGradMap2(float*** img,float** matout,int lgth,int wdth,int dist)
{
  int i,j,k;
  int posrA,poscA,posrB,poscB;
  float tmp;

  //Loop
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) matout[i][j]=0.0;

  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    { 
      posrB=i-dist;
      poscB=j-dist;
      posrA=i+dist;
      poscA=j+dist;

      if (posrB<0)        posrB+=lgth;
      if (poscB<0)        poscB+=wdth;
      if (posrA>(lgth-1)) posrA-=lgth;
      if (poscA>(wdth-1)) poscA-=wdth; 

      tmp=0.0;
      for(k=0;k<TROIS;k++) 
	{ tmp+=fabs(img[k][posrB][j]-img[k][posrA][j])+fabs(img[k][i][poscB]-img[k][i][poscA]);
          tmp+=fabs(img[k][posrB][poscA]-img[k][posrA][poscB])+fabs(img[k][posrB][poscB]-img[k][posrA][poscA]);
        }
      matout[i][j]=tmp; }

  //Recal
  Recal(matout,lgth,wdth);
}

//----------------------------------------------------------
// SEG >> SEG_Paint
//----------------------------------------------------------
// Paint
//----------------------------------------------------------
void MD2S::SEG_Paint(float** mat,float** mattmp,int row,int col,int lgth,int wdth,int lab)
{
   if ((mattmp[row][col]==0)&&(mat[row][col]==lab))
    {
     mattmp[row][col]=-1;

     if ((col+1)<=(wdth-1))   SEG_Paint(mat,mattmp,row,col+1,lgth,wdth,lab);
     if ((col-1)>=0)          SEG_Paint(mat,mattmp,row,col-1,lgth,wdth,lab);
     if ((row+1)<=(lgth-1))   SEG_Paint(mat,mattmp,row+1,col,lgth,wdth,lab);
     if ((row-1)>=0)          SEG_Paint(mat,mattmp,row-1,col,lgth,wdth,lab);
     }

 else return;
}

//----------------------------------------------------------
// SEG >> SEG_Paint
//----------------------------------------------------------
// Paint
//----------------------------------------------------------
void MD2S::SEG_Paint(float** mat,int** mattmp,int row,int col,int lgth,int wdth,int lab)
{
 if ((mattmp[row][col]==0)&&(mat[row][col]==lab))
    {
     mattmp[row][col]=-1;

     if ((col+1)<=(wdth-1))  SEG_Paint(mat,mattmp,row,col+1,lgth,wdth,lab);
     if ((col-1)>=0)         SEG_Paint(mat,mattmp,row,col-1,lgth,wdth,lab);
     if ((row+1)<=(lgth-1))  SEG_Paint(mat,mattmp,row+1,col,lgth,wdth,lab);
     if ((row-1)>=0)         SEG_Paint(mat,mattmp,row-1,col,lgth,wdth,lab);
     }

 else return;
}

//----------------------------------------------------------
// SEG >> SEG_ConvertCertainClassRegionInf
//----------------------------------------------------------
// ConvertCertainClassRegionIng <On ne VisitePasClass[0]>
//----------------------------------------------------------
void MD2S::SEG_ConvertCertainClassRegionInf(float** mat,int lgth,int wdth)
{
 int i,j,k,l;
 int label;
 int cpt;

  //Allocation
  int** mattmp=imatrix_allocate_2d(lgth,wdth);

  //Init
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) mattmp[i][j]=0;
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) mat[i][j]=(int)mat[i][j];

 //Class[0]>Visite
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) if (mat[i][j]==0) mattmp[i][j]=-2;

  //Boucle
  //-------
  cpt=0;
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
     if (mattmp[i][j]==0)
        {
         label=(int)mat[i][j];
         SEG_Paint(mat,mattmp,i,j,lgth,wdth,label);

         ++cpt;

         for(k=0;k<lgth;k++) for(l=0;l<wdth;l++)
           if (mattmp[k][l]==-1) mat[k][l]=cpt;

         for(k=0;k<lgth;k++) for(l=0;l<wdth;l++)
           if (mattmp[k][l]==-1) mattmp[k][l]=-2;
        }

   //Compte Regions
   printf("\n >> NbRegions [%d]",cpt);
   fflush(stdout);

 //Liberation
 free_imatrix_2d(mattmp);
}

//----------------------------------------------------------
// SEG >> ContrainWithSeg
//----------------------------------------------------------
// ContrainWithSeg(float**,int,int,float**)
//
// Nota: float**overseg en NbRegions
//----------------------------------------------------------
void MD2S::SEG_ContrainWithSeg(float** overseg,int lgth,int wdth,float** seg)
{
  int i,j;
 int NbRegions;
 int NbClasses;
 float ClassMax;
 float ValClassMax;
 float** MatClass;
 float** segtmp;

 //Allocation Memoire
 segtmp=fmatrix_allocate_2d(lgth,wdth);

 //Calcul NbRegions
 NbRegions=0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
   if (overseg[i][j]>NbRegions) NbRegions=(int)overseg[i][j];

 //Calcul NbClasses
 NbClasses=0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
   if (seg[i][j]>NbClasses) NbClasses=(int)seg[i][j];  //!!!(int)overseg[i][j]

 //Info
 NbRegions++;
 NbClasses++;
 if (0)
   { printf("\n\n  ConstrainSeg >> NbRegionsMax[%d] Classes[%d]      ",NbRegions,NbClasses);
     fflush(stdout); }

 //Reservation Memoire
 MatClass=fmatrix_allocate_2d(NbRegions,(NbClasses+1));
 for(i=0;i<NbRegions;i++) for(j=0;j<(NbClasses+1);j++)  MatClass[i][j]=0.0;

 //Remplissage MatClass
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) MatClass[(int)(overseg[i][j])][(int)(seg[i][j])]++;

 //ChercheMax
 for(i=0;i<NbRegions;i++)
   { ClassMax=0;
     ValClassMax=0;
     for(j=0;j<NbClasses;j++) if (MatClass[i][j]>ValClassMax) { ValClassMax=MatClass[i][j]; ClassMax=j; }

     MatClass[i][NbClasses]=ClassMax; }

 //Contrain
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
   { if (overseg[i][j]) segtmp[i][j]=MatClass[(int)overseg[i][j]][NbClasses];
     else  segtmp[i][j]=seg[i][j]; }

 //Copie
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) seg[i][j]=segtmp[i][j];

 //Liberation
 if (MatClass)  free_fmatrix_2d(MatClass);
 if (segtmp)    free_fmatrix_2d(segtmp);
}

//----------------------------------------------------------
// SEG >> SEG_Identical
//----------------------------------------------------------
// Identical                      
//----------------------------------------------------------
int MD2S::SEG_Identical(int* VctPts,int** MtxCtrs,int nbcl,int nbpar)
{
 int k,l;
 int value=0;

 for(k=0;k<nbcl;k++) 
   { value=1;
     for(l=0;l<nbpar;l++) if (VctPts[l]!=MtxCtrs[k][l]) value=0;
     if (value) return value; }
    
 return value;
}

//----------------------------------------------------------
// SEG >> SEG_KmeanFast
//----------------------------------------------------------
//  K-Mean  <Avec Entiers>
//----------------------------------------------------------
void MD2S::SEG_KmeanFast(int** MatrixPts,int NbClusters,int NbPts,int NbParam,int* VctLabel,int Seed,int FlgMan)
{
 int i,j,k,l;
 int classe;
 float aleat;
 int nb;
 float  dist,distmin;
 int flag;
 
 //Allocation memoire
 int** MatrixCtrs=imatrix_allocate_2d(NbClusters,NbParam);
 
 //Presentation
 printf("\n  <Seed:%d> -> Funct.Kmean",Seed);
 srand(Seed);
 if (FlgMan) printf("\n  K-Moy > [Dist. Manhattan]"); 


 //--------------------------------------------------------------
 // -[0]- Initialize Centroid
 // --------------------------------------------------------------
  if (0)                    
  for(i=0;i<NbClusters;i++) 
     { aleat=(i+1)*(NbPts/(NbClusters+2));
       for(k=0;k<NbParam;k++) MatrixCtrs[i][k]=MatrixPts[(int)aleat][k]; } 

  if (1)
  for(i=0;i<NbClusters;i++) 
   { nb=0;
     do { aleat=(int)((randomize())*NbPts-1); nb++; }
     while((i)&&(nb<100)&&(SEG_Identical(MatrixPts[(int)aleat],MatrixCtrs,NbClusters,NbParam)));

     if (nb>1) printf(" <|%d Essais|>",nb);

     for(k=0;k<NbParam;k++) MatrixCtrs[i][k]=MatrixPts[(int)aleat][k]; } 
  //------------------------------------------------------------------
  //------------------------------------------------------------------
    
 
  printf("\n    ");
 //================================================================
 //BOUCLE =========================================================
 //================================================================
 for(l=0;l<50;l++)
   {  
       //-[1]- Select Cluster Membership
       //-------------------------------
       flag=0; classe=0;

       for(j=0;j<NbPts;j++)
          { distmin=BIGNUMBER;  

           for(i=0;i<NbClusters;i++)
              { dist=0.0; 
                
                //Euclidean distance
                if (!FlgMan)
                for(k=0;k<NbParam;k++) dist+=CARRE(MatrixCtrs[i][k]-MatrixPts[j][k]);

                //Manhattan distance
		if (FlgMan)
                for(k=0;k<NbParam;k++) dist+=abs(MatrixCtrs[i][k]-MatrixPts[j][k]);
		     
                if (dist<distmin) { distmin=dist; classe=i; }
	      }            
           if (VctLabel[j]!=classe) { VctLabel[j]=classe; flag++; }
	  }

       //-[2]- Stop Criterion & Info
       //---------------------------
       if ((!flag)&&(l>2))  break;
       printf("[%d>%d]",l,flag); fflush(stdout);
          
       
       //-[3]- Update Centroids For Each Clusters
       //----------------------------------------
        for(i=0;i<NbClusters;i++) 
	  {  
           nb=0;    
	   for(k=0;k<NbParam;k++) MatrixCtrs[i][k]=0;
                      
	   for(j=0;j<NbPts;j++) if (VctLabel[j]==i)
	      { nb++;
                for(k=0;k<NbParam;k++) MatrixCtrs[i][k]+=MatrixPts[j][k]; }

           for(k=0;k<NbParam;k++) if (nb) MatrixCtrs[i][k]/=nb;
          }

   }//==============================================================
 //================================================================= 

 //FreeMemory
 if (MatrixCtrs) free_imatrix_2d(MatrixCtrs);
}

//----------------------------------------------------------
// SEG >> SEG_KmeanFast
//----------------------------------------------------------
//  K-Mean  <Avec Entiers> <Contraint>
//----------------------------------------------------------
void MD2S::SEG_KmeanFast(int** MatrixPts,int NbClusters,int NbPts,int NbParam,int* VctLabel,int Seed,\
		int FlgMan,float** Pot,int lgth,int wdth,float thresh)
{
 int i,j,k,l;
 int classe;
 float aleat;
 int nb;
 float  dist,distmin;
 int flag;


 //Allocation memoire
 int** MatrixCtrs=imatrix_allocate_2d(NbClusters,NbParam);
 float** MatTmp=fmatrix_allocate_2d(lgth,wdth);
 float** MatPot=fmatrix_allocate_2d(lgth,wdth);
 float** InvVar=fmatrix_allocate_2d(NbClusters,NbParam);
 float*  Prop=fmatrix_allocate_1d(NbClusters);

 //Preparation Contrainte
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    { if (Pot[i][j]>=254) MatPot[i][j]=254;
      else MatPot[i][j]=Pot[i][j]; }

 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
   { if (MatPot[i][j]<=(thresh*255)) MatPot[i][j]=255.0; 
     else MatPot[i][j]=0.0; }

 //for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) MatPot[i][j]=Pot[i][j];
     
 SEG_ConvertCertainClassRegionInf(MatPot,lgth,wdth);
 //ConvertClassRegionInf(MatPot,lgth,wdth);

 //Debug
 //SaveImagePgm("POT","",MatPot,lgth,wdth);
 //exit(-1);
 
 //Presentation
 printf("\n  <Seed:%d> -> Funct.Kmean [RegulSeg=%.3f]",Seed,thresh);
 //srand(Seed);
 srand(0);
 if (FlgMan) printf("\n  K-Moy > [Dist. Manhattan]"); 


 //--------------------------------------------------------------
 // -[0]- Initialize Centroid
 // --------------------------------------------------------------
  if (0)                    
  for(i=0;i<NbClusters;i++) 
     { aleat=(i+1)*(NbPts/(NbClusters+2));
       for(k=0;k<NbParam;k++) MatrixCtrs[i][k]=MatrixPts[(int)aleat][k]; } 

  if (1)
  for(i=0;i<NbClusters;i++) 
   { nb=0;
     do { aleat=(int)((randomize())*NbPts-1); nb++; }
     while((i)&&(nb<100)&&(SEG_Identical(MatrixPts[(int)aleat],MatrixCtrs,NbClusters,NbParam)));

     if (nb>1) printf(" <|%d Essais|>",nb);

     for(k=0;k<NbParam;k++) MatrixCtrs[i][k]=MatrixPts[(int)aleat][k]; } 
  //------------------------------------------------------------------
  //------------------------------------------------------------------
    
 
  printf("\n    ");
 //================================================================
 //BOUCLE =========================================================
 //================================================================
 for(l=0;l<38;l++)
   {  
       //-[1]- Select Cluster Membership
       //-------------------------------
       flag=0; classe=0;

       for(j=0;j<NbPts;j++)
          { distmin=BIGNUMBER;  

           for(i=0;i<NbClusters;i++)
              { dist=0.0; 
                
                //Euclidean distance
                if (!FlgMan) for(k=0;k<NbParam;k++) dist+=CARRE(MatrixCtrs[i][k]-MatrixPts[j][k]);

                //Manhattan distance
		if (FlgMan) for(k=0;k<NbParam;k++) dist+=abs(MatrixCtrs[i][k]-MatrixPts[j][k]);
		     
                if (dist<distmin) { distmin=dist; classe=i; }
	      }            
           if (VctLabel[j]!=classe) { VctLabel[j]=classe; flag++; }
	  }

       //-[1b]- Contrainte
       //-----------------
       if (l>10)  //(l>10)
          { for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)  MatTmp[i][j]=VctLabel[(i*wdth)+j]; 
            SEG_ContrainWithSeg(MatPot,lgth,wdth,MatTmp);
            for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)  VctLabel[(i*wdth)+j]=(int)MatTmp[i][j]; 
            printf("C"); }


       //-[2]- Stop Criterion & Info
       //---------------------------
       if ((!flag)&&(l>2))  break;
       printf("[%d>%d]",l,flag); fflush(stdout);
          
       
       //-[3]- Update Centroids For Each Clusters
       //----------------------------------------
        for(i=0;i<NbClusters;i++) 
	  {  
           nb=0;    
	   for(k=0;k<NbParam;k++) MatrixCtrs[i][k]=0;
                      
	   for(j=0;j<NbPts;j++) if (VctLabel[j]==i)
	      { nb++;
                for(k=0;k<NbParam;k++) MatrixCtrs[i][k]+=MatrixPts[j][k]; }

           for(k=0;k<NbParam;k++) if (nb) MatrixCtrs[i][k]/=nb;
          }

   }//==============================================================
 //================================================================= 

 //FreeMemory
 if (MatrixCtrs) free_imatrix_2d(MatrixCtrs);
 if (MatTmp)     free_fmatrix_2d(MatTmp);
 if (MatPot)     free_fmatrix_2d(MatPot);
 if (InvVar)     free_fmatrix_2d(InvVar); 
 if (Prop)       free_fmatrix_1d(Prop); 
}

//----------------------------------------------------------
// SEG >> SEG_ConvertClassRegion
//----------------------------------------------------------
// Convert <ClassRegion>              
//----------------------------------------------------------
void MD2S::SEG_ConvertClassRegion(float** mat,int lgth,int wdth)
{
 int i,j,k,l,m;
 int label;
 float coul;
 int nb;
 int cpt;
 
  //Allocation 
  int** mattmp=imatrix_allocate_2d(lgth,wdth);
  int*  TabGrey=imatrix_allocate_1d(256);
  
  //Init 
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) mattmp[i][j]=0;
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) mat[i][j]=(int)mat[i][j];
  for(i=0;i<256;i++)  TabGrey[i]=0;

  //Check
   for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
     if ((mat[i][j]>=0)&&(mat[i][j]<256)) TabGrey[int(mat[i][j])]++;

   for(nb=0,i=0;i<256;i++)  if (TabGrey[i]) nb++;
   printf("\n >> NbClasses [%d]",nb);
   fflush(stdout);
   for(i=0;i<256;i++)  TabGrey[i]=0; 

  //Boucle
  //-------
  cpt=0;
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
     if (mattmp[i][j]==0)
        {
	 label=(int)mat[i][j];

         SEG_Paint(mat,mattmp,i,j,lgth,wdth,label);

         do 
           { coul=(int)(randomize()*255); }
         while (TabGrey[(int)coul]);

         TabGrey[(int)coul]=1;
         ++cpt;
         
         if (cpt>=255)
	    { for(m=0;m<256;m++)  TabGrey[m]=0;
              cpt=0; printf("*Regions debordent*"); }        

         for(k=0;k<lgth;k++) for(l=0;l<wdth;l++)
	   if (mattmp[k][l]==-1) mat[k][l]=(int)coul;

         for(k=0;k<lgth;k++) for(l=0;l<wdth;l++)
	   if (mattmp[k][l]==-1) mattmp[k][l]=-2;
        }
 
   //Compte Regions
   for(i=0;i<256;i++)  TabGrey[i]=0;
      
   for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) TabGrey[int(mat[i][j])]++;

   for(nb=0,i=0;i<256;i++)  if (TabGrey[i]) nb++;
       printf("\n >> NbRegions [%d]",nb);
   fflush(stdout);

 //Liberation 
 free_imatrix_2d(mattmp); 
 free_imatrix_1d(TabGrey); 
}

//----------------------------------------------------------
// SEG >> SEG_FuseSmallRegions(
//----------------------------------------------------------
// FuseRegions
//
// < Petite regions inferieur taille sz fusione avec
//    classe majoritaire l entourant >
//
//----------------------------------------------------------
int MD2S::SEG_FuseSmallRegions(float** mat,int lgth,int wdth,int* nbreg,int sz,float elg)
{
 int i,j,k,l,m,n,t;
 float maxim;
 int  labfuse;
 int cpt;
 int initsize;
 int size_min;
 int nbregion_prec;
 int nbregion_init;
 int NbChgt;
 float Elong;
 int nbper;
 int cl;

 //Allocation
 float**  mattmp=fmatrix_allocate_2d(lgth,wdth);
 float*   claslb=fmatrix_allocate_1d(256);

 //Init
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) mat[i][j]=(int)mat[i][j];
 NbChgt=0;

 //Init
 size_min=0;
 nbregion_prec=0;
 cpt=10;
 printf("\n  FuseSmallRegions[%d]",sz);
 printf("\n  Regions>");

 //BOUCLE
 //========================================================================
 for(t=0;((t<12)&&(size_min<sz)&&(nbregion_prec!=cpt));t++)
   {

    //Init
    for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) mattmp[i][j]=0;

       //Boucle
       //-------------------------------------
        for(cpt=0,i=0;i<lgth;i++) for(j=0;j<wdth;j++) if (mattmp[i][j]==0)
              {
               initsize=0;
               SEG_Paint(mat,mattmp,i,j,lgth,wdth,(int)mat[i][j]);
               ++cpt;
               for(k=0;k<256;k++)  claslb[k]=0;

               //RegionsVoisines
               for(k=0;k<lgth;k++) for(l=0;l<wdth;l++) if (mattmp[k][l]==-1)
                    { initsize++;
                      for(m=-1;m<2;m++) for(n=-1;n<2;n++)
                        if (((k+m)>=0)&&((k+m)<lgth)&&((l+n)>=0)&&((l+n)<wdth))
                            if (mat[k+m][l+n]<256) claslb[(int)mat[k+m][l+n]]++;  }

               claslb[(int)mat[i][j]]=0;

               //ClasseVoisineMajoritaire
               labfuse=0;
               maxim=0;
               for(k=0;k<256;k++) if (claslb[k]>maxim) { maxim=claslb[k]; labfuse=k; };

               //Calcul Elongation
               nbper=0;
               cl=(int)mat[i][j];
               for(k=1;k<(lgth-1);k++) for(l=1;l<(wdth-1);l++) if (mat[k][l]==cl)
                 { if ((mat[k-1][l]!=cl)||(mat[k+1][l]!=cl)||(mat[k][l+1]!=cl)||(mat[k][l-1]!=cl))
                   nbper++; }

               Elong=((4*PI*initsize/CARRE(nbper))*100);
               //printf("<%.3f>",Elong);

               //SiCond. { [Size(region)<sz] || [Elong(region)<elg]] ==> Fusion
               if ((initsize<=sz)||(Elong<=elg))
                  { for(k=0;k<lgth;k++) for(l=0;l<wdth;l++) if (mattmp[k][l]==-1)
                    mat[k][l]=labfuse;
                    NbChgt++; }

               for(k=0;k<lgth;k++) for(l=0;l<wdth;l++) if (mattmp[k][l]==-1) mattmp[k][l]=-2;
              }//---------------------------

     nbregion_init=cpt;
     size_min=lgth*wdth;
     for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) mattmp[i][j]=0;

     nbregion_prec=cpt;
     for(cpt=0,i=0;i<lgth;i++) for(j=0;j<wdth;j++) if (mattmp[i][j]==0)
        {
         initsize=0;
         SEG_Paint(mat,mattmp,i,j,lgth,wdth,(int)mat[i][j]);
         ++cpt;

         for(k=0;k<lgth;k++) for(l=0;l<wdth;l++) if (mattmp[k][l]==-1)  initsize++;

         if (initsize<size_min) size_min=initsize;

         for(k=0;k<lgth;k++) for(l=0;l<wdth;l++) if (mattmp[k][l]==-1) mattmp[k][l]=-2;
       }

      printf("(>%d)",cpt);
      (*nbreg)=cpt;
      fflush(stdout);
   }//=====================================================================

 //Liberation
 if (mattmp)  free_fmatrix_2d(mattmp);
 if (claslb)  free_fmatrix_1d(claslb);

 //Retour
 printf("   |NbChgt >[%d]",NbChgt);
 return NbChgt;
}

//=========================================================================
//=========================================================================
//>NETTOYAGE ==============================================================
//=========================================================================
//=========================================================================
//----------------------------------------------------------
// SEG >> SEG_MedianFilter
//----------------------------------------------------------
// MedianFilter
//      voisinage SzN*SzN
//----------------------------------------------------------
void MD2S::SEG_MedianFilter(float** mt,int lgth,int wdth,int SzN) 
{
 int i,j,k,l,m;
 int nb;
 float tmp;

 float** mat_tmp;
 float* vect;

 //reservation memoire
 mat_tmp=fmatrix_allocate_2d(lgth,wdth);
 vect=fmatrix_allocate_1d(SzN*SzN);

 //recopie matrice
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    mat_tmp[i][j]=mt[i][j];

 //Filtre median
 for(i=(SzN/2);i<(lgth-(SzN/2));i++) for(j=(SzN/2);j<(wdth-(SzN/2));j++)
   {
    nb=0;
    for(k=-(SzN/2);k<=(SzN/2);k++) for(l=-(SzN/2);l<=(SzN/2);l++)  
        vect[nb++]=mat_tmp[i+k][j+l];

    for(l=0;l<((SzN*SzN)-1);l++) for(m=0;m<((SzN*SzN)-1);m++)
       if (vect[m]>vect[m+1]) 
          { tmp=vect[m];
            vect[m]=vect[m+1];
            vect[m+1]=tmp; } 

   mt[i][j]=vect[((SzN*SzN)/2)]; 

   //Debug
   //for(k=0;k<(SzN*SzN);k++) printf("[%.0f]",vect[k]);
   //printf(">>>[%.0f]\n",mt[i][j]);
   }

 //liberation memoire
 free_fmatrix_2d(mat_tmp);
 free(vect); 
}

//----------------------------------------------------------
// SEG >> SEG_AddContourImg
//----------------------------------------------------------
// AddContour                               
//----------------------------------------------------------
void MD2S::SEG_AddContourImg(float** seg,float*** img,int lgth,int wdth,int gross) 
{
 int i,j,k,l;
 float tmp;
 int dep;

 //Init
 dep=(int)(gross/2);

 //AllocationMemoire
 float** mat_tmp=fmatrix_allocate_2d(lgth,wdth);
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) mat_tmp[i][j]=255.0;

 //Gradient
 for(i=1;i<(lgth-1);i++) for(j=1;j<(wdth-1);j++)
   { tmp=sqrt(CARRE(seg[i+1][j]-seg[i][j])+CARRE(seg[i][j+1]-seg[i][j]));
     if (tmp>0) mat_tmp[i][j]=0.0; }

 //Boucle
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) if (mat_tmp[i][j]==0.0)
      {
       for(k=-dep;k<=dep;k++) for(l=-dep;l<=dep;l++)
	 if (((i+k)>0)&&((i+k)<lgth)&&((j+l)>0)&&((j+l)<wdth))
	  { img[0][i+k][j+l]=0; 
            img[1][i+k][j+l]=0; 
            img[2][i+k][j+l]=0; }
      }    

 //liberation memoire
 free_fmatrix_2d(mat_tmp); 
}
